// RGB_Pulser -- combines 3 Pulser's which extends the basic Flasher interface

#ifndef _RGB_Pulser_h_
#define _RGB_Pulser_h_

#include "Flasher.h"
#include "Pulser.h"

#define RGB_PULSER_VERSION "$Id: RGB_Pulser.h 9 2018-10-01 07:19:06Z cafelizardo $"

class RGB_Pulser : public Pulser
{
    Pulser *red_led, *green_led, *blue_led;

    public:
    // ctor
    RGB_Pulser(int red_pin, int green_pin, int blue_pin, int interval = 0, int maxValue = 255)
    {
        this->red_led = new Pulser(red_pin, interval, maxValue);
        this->green_led = new Pulser(green_pin, interval, maxValue);
        this->blue_led = new Pulser(blue_pin, interval, maxValue);
    }

    // access functions for Pulser objects
    Pulser* red() { return this->red_led; }
    Pulser* green() { return this->green_led; }
    Pulser* blue() { return this->blue_led; }

    virtual RGB_Pulser& output(int red, int green, int blue) {
        this->red_led->output(red);
        this->green_led->output(blue);
        this->blue_led->output(green);
    }
    virtual RGB_Pulser& output(long rgb) {
#if 0
        Serial.print(F("RGB_Pulser.output "));
        Serial.print(rgb, HEX); Serial.print(F(" "));
        Serial.print((rgb & 0xff0000) >> 16, HEX); Serial.print(F(" "));
        Serial.print((rgb & 0x00ff00) >> 8, 16); Serial.print(F(" "));
        Serial.print(rgb & 0x0000ff, 16); 
        Serial.println();
#endif
        this->red_led->output((rgb & 0xff0000) >> 16);
        this->green_led->output((rgb & 0x00ff00) >> 8);
        this->blue_led->output(rgb & 0x0000ff);
        return *this;
    }
    virtual RGB_Pulser& disable() {
        Serial.println("RGB_light.disable ");
        this->red_led->disable();   this->red_led->output(255);
        this->green_led->disable(); this->green_led->output(255);
        this->blue_led->disable();  this->blue_led->output(255);
        return *this;
    }
    virtual RGB_Pulser& enable() {
        Serial.println("RGB_light.enable ");
        this->red_led->enable();
        this->green_led->enable();
        this->blue_led->enable();
        return *this;
    }
    virtual RGB_Pulser& update()
    {
        //Serial.println("RGB_light.update ");
        this->red_led->update();
        this->green_led->update();
        this->blue_led->update();
        return *this;
    }
}; // class RGB_Pulser

#endif // _RGB_Pulser_h
